#!/bin/sh
. /etc/linuxigd/Layer3Forwarding
. /var/state/ppp/default_ppp		# For default ppp

if [ -f /etc/linuxigd/WANIPAddress ]; then
	. /etc/linuxigd/WANIPAddress
else
	exit 0
fi

Action=$1
LocalIP=$2
PortRange=$3

if [ "$4" != "" ]; then
   LocalIP=$LocalIP:$4
fi

if [ "$Action" = "Set" ]; then
   if [ "$x_ConnectionType" = "PPPoE" ] || [ "$x_ConnectionType" = "PPTP" ]; then
	  WAN_IF="$default_ppp"
   else
	  WAN_IF="eth1"
   fi
   echo "Set port mapping $PortRange to $LocalIP"
   if [ "$WANIPAddress" != "" ]; then	
       iptables -t nat -A PREROUTING -p tcp -i $WAN_IF -d $WANIPAddress --dport $PortRange -j DNAT --to $LocalIP
   	   iptables -t nat -A PREROUTING -p udp -i $WAN_IF -d $WANIPAddress --dport $PortRange -j DNAT --to $LocalIP
   fi
else
   echo "Unset port mappin $PortRange to $LocalIP"
   rule=`iptables -t nat -L PREROUTING | grep "$LocalIP" -n | grep "$PortRange" | grep "tcp" | sed 's/:.*//'`
   if [ "$rule" != "" ]; then
		for i in $rule ; do
   			i=$(($i-2))	
   			echo "Remove" $i   	   	
   			iptables -t nat -D PREROUTING $i
			# Rmove one rule, even there are more than one match
			break
		done
   fi   			
   rule=`iptables -t nat -L PREROUTING | grep "$LocalIP" -n | grep "$PortRange" | grep "udp" | sed 's/:.*//'`
   if [ "$rule" != "" ]; then
		for i in $rule ; do
	 		i=$(($i-2))
			echo "Remove" $i
			iptables -t nat -D PREROUTING $i
			break;
 		done
   fi
fi
