#!/bin/sh
. /etc/linuxigd/Layer3Forwarding
. /etc/linuxigd/IPConnection
. /etc/linuxigd/LANHostConfig

if [ "$x_ConnectionType" = "Static IP" ]; then
	WANIPAddress="$ExternalIPAddress"
	WANSubnetMask="$x_ExternalSubnetMask"
	WANGateway="$x_ExternalGateway"
	WANDNSServer="$x_DNSServer1"
	if [ "$x_DNSServer2" != "" ]; then
		WANDNSServer="$WANDNSServer,$x_DNSServer2"
	fi
	WANLink="(Not used for Static IP)"
elif [ "$x_ConnectionType" = "Automatic IP" ]; then
	if [ -f /var/state/udhcpc/dhclient.state ]; then
		. /var/state/udhcpc/dhclient.state
		if [ "$ip" != "" ]; then
			WANIPAddress="$ip"
			WANSubnetMask="$subnet"
			WANGateway="$router"
			WANDNSServer="$dns"
			spent=`wlanutil uptime $time`
			ltime=$(($lease-$spent))
			WANLink="Lease time is $ltime"
		else
			WANLink="Disconnected"
		fi
		
	else
		WANLink="Disconnected"
	fi	
elif [ "$x_ConnectionType" = "PPPoE" ] || [ "$x_ConnectionType" = "PPTP" ]; then
	if [ -f /var/state/ppp/ppp.state ]; then
		. /var/state/ppp/ppp.state
		WANLink="$PPPSTATE"
		WANIPAddress="$LOCAL_IP"
		WANSubnetMask="$PPP_NETMASK"
		WANGateway="$REMOTE_IP"
		if [ "$DNS1" != "" ]; then
			if [ "$DNS2" != "" ]; then
				WANDNSServer="$DNS1,$DNS2"
			else
				WANDNSServer="$DNS1"
			fi
		else
			WANDNSServer=""
		fi	
	else
		WANLink="Disconnected"
	fi
else
	WANLink="Disconnected"
fi

DDNSIP=`nvram get ddns_wanip`

echo WANType=\"$x_ConnectionType\" > /etc/linuxigd/wan.log
echo WANLink=\"$WANLink\" >> /etc/linuxigd/wan.log
echo WANIPAddress=\"$WANIPAddress\" >> /etc/linuxigd/wan.log
echo WANSubnetMask=\"$WANSubnetMask\" >> /etc/linuxigd/wan.log
echo WANGateway=\"$WANGateway\" >> /etc/linuxigd/wan.log
echo WANDNSServer=\"$WANDNSServer\" >> /etc/linuxigd/wan.log
echo WANDDNSIP=\"$DDNSIP\" >> /etc/linuxigd/wan.log
